<?php
/**
 * Shows a widget which allow for viewing blog entries by authors.
 * 
 * @package blog
 */
class AuthorWidget extends Widget {
	// static $db = array(
		// 'DisplayMode' => 'Varchar'
	// );
	
	// static $defaults = array(
		// 'DisplayMode' => 'month'
	// );
	
	static $title = 'Auteurs';

	static $cmsTitle = 'Blog Authors';
	
	static $description = 'Show a list of authors and provide links to their blog posts.';
	
	function getBlogHolder() {
		$page = Director::currentPage();
		
		if($page instanceof BlogHolder) {
			return $page;
		} elseif(($page instanceof BlogEntry) && ($page->getParent() instanceof BlogHolder)) {
			return $page->getParent();
		} else {
			return DataObject::get_one('BlogHolder');
		}
	}
	
	// function getCMSFields() {
		// return new FieldSet(
			// new OptionsetField(
				// 'DisplayMode',
				// _t('ArchiveWidget.DispBY', 'Display by'),
				// array(
					// 'month' => _t('ArchiveWidget.MONTH', 'month'),
					// 'year' => _t('ArchiveWidget.YEAR', 'year')
				// )
			// )
		// );
	// }
	
	function Authors() {
		Requirements::themedCSS('authorwidget');
		
		$results = new DataObjectSet();
		$blogHolder = $this->getBlogHolder();
		$id = $blogHolder->ID;
		
		$stage = Versioned::current_stage();
		$suffix = (!$stage || $stage == 'Stage') ? "" : "_$stage";
		
		$sqlResults = DB::query("SELECT Author, COUNT(*) AS BlogEntries FROM `SiteTree$suffix` NATURAL JOIN `BlogEntry$suffix` WHERE `ParentID` = $id GROUP BY Author ORDER BY BlogEntries DESC");
		
		if(!$sqlResults) return new DataObjectSet();
		
		foreach($sqlResults as $sqlResult) {
			$author = $sqlResult['Author'];
			$blogentries = $sqlResult['BlogEntries'];
			$link = $blogHolder->Link() . 'author/' . urlencode($sqlResult['Author']);
					
			$results->push(new ArrayData(array(
				'Author' => $author,
				'BlogEntries' => $blogentries,
				'Link' => $link
			)));
		}
		
		return $results;
	}

}
?>
